{% extends "base.html" %}
{% set active_page = "launch" %}
{% block body %}
<form action="/launch" name="mainFrom" id="uploadForm" method="POST" enctype=multipart/form-data>
  <fieldset class="uk-fieldset">

    <legend class="uk-legend">Launch a Workflow</legend>
    <input type="hidden" name="type" value="custom">
    <div class="uk-margin">
      <label>Workflow CWL input method</label>
      <br>
      <div>
        <input type="radio" name="workflow_cwl_input_method" id="workflowSource" value="xx">
        <label for="workflowSource">Upload a cwl file</label>
        <div class="reveal-if-active">
          <input type="file" id="cwl_file" name="workflowSource" class="require-if-active"
            data-require-pair="#workflowSource">
        </div>
      </div>
      <div>
        <input type="radio" name="workflow_cwl_input_method" id="workflowUrl" value="xx">
        <label for="workflowUrl">Give a url that gets the cwl file</label>
        <div class="reveal-if-active">
          <input type="text" id="cwl_url" name="workflowUrl" class="require-if-active" data-require-pair="#workflowUrl">
        </div>
      </div>
    </div>

    <div class="uk-margin">
      <label>Workflow INPUTS YAML input method</label>
      <br>
      <div>
        <input type="radio" name="workflow_yaml_input_method" id="inputs_local" value="local">
        <label for="inputs_local">Upload a yaml file</label>
        <div class="reveal-if-active">
          <input type="file" id="yaml_file" name="inputs_local" class="require-if-active"
            data-require-pair="#inputs_local">
        </div>
      </div>
      <div>
        <input type="radio" name="workflow_yaml_input_method" id="inputs_url" value="url">
        <label for="inputs_url">Give an url that gets the yaml file</label>
        <div class="reveal-if-active">
          <input type="text" id="yaml_url" name="inputs_url" class="require-if-active" data-require-pair="#inputs_url">
        </div>
      </div>
      <div>
        <input type="radio" name="workflow_yaml_input_method" id="workflowReference" value="xx">
        <label for="workflowReference">Give an ID of a previous successful run. Your cwl will run against exactly those
          inputs and at metadata you will also find outputs paths of that previous run.</label>
        <div class="reveal-if-active">
          <input type="text" id="yaml_reference" name="workflowReference" class="require-if-active"
            data-require-pair="#workflowReference">
        </div>
      </div>
    </div>

    <div class="uk-margin">
      <label>Additional files as input. The parameters are extracted from the yaml file you provided earlier.</label>
      <label>If you want as a parameter the file located at the path (in s3), that is already set in the yaml, leave the
        corresponding form field unset.</label>
      <br> <br>
      <div id="parameters_container">
      </div>
    </div>
    <br> <br>
    {% block content %}
    {% if status is defined%}
    <br>
    {{ status }}
    <br> <br>
    {% endif %}
    {% endblock %}
    <div class="uk-margin" id="statusText" style="display:none">
    </div>
    <button type="submit" id="submitButton" class="uk-button uk-button-primary uk-button-large">Submit</button>
    <div class="uk-margin" id="uploadingText" style="display:none">
      Uploading the files, please wait.
    </div>
    <div class="w3-light-grey" id="progressBar" style="display:none">
      <div class="w3-blue" id="progressBarFill" role="progressbar" style="width: 0%" aria-valuenow="0" aria-valuemin="0"
        aria-valuemax="100">
        <span class="progress-bar-text" id="progressBarText">0%</span>
      </div>
    </div>

  </fieldset>
</form>


<script>
  var getParametersButton = document.getElementById("getParametersButton");
  var uploadForm = document.getElementById("uploadForm");
  var progressBar = document.getElementById("progressBar");
  var progressBarFill = document.getElementById("progressBarFill");
  var progressBarText = document.getElementById("progressBarText");
  var statusText = document.getElementById("statusText")
  var uploadText = document.getElementById("uploadingText");
  var submitButton = document.getElementById("submitButton");
  uploadForm.addEventListener("submit", sendForm);

  var inputs_local = document.getElementById("yaml_file");

  var local_yaml = document.getElementById("yaml_file");
  var url_yaml = document.getElementById("yaml_url");

  const container = document.getElementById("parameters_container");

  //function to send yaml file and extract the extra input parameters from response
  function uploadYaml(file) {
    const request = new XMLHttpRequest();
    const formData = new FormData();
    request.open("POST", "/extract_parameters", true);
    request.onreadystatechange = () => {
      if (request.readyState === 4 && request.status === 200) {
        var param = JSON.parse(request.responseText);
        const keys = Object.keys(param);
        while (container.hasChildNodes()) {
          container.removeChild(container.lastChild);
        }
        for (let i = 0; i < keys.length; i++) {
          const key = keys[i];
          console.log(key, param[key]);
          var input = document.createElement("input");
          var text_node = document.createTextNode(key + ": ");
          var line_break = document.createElement("br");

          input.type = param[key];
          input.name = key;
          container.appendChild(text_node);
          container.appendChild(input);
          container.appendChild(line_break);
        }
      }
      else if (request.readyState === 4) {
        while (container.hasChildNodes()) {
          container.removeChild(container.lastChild);
        }
      }
    };
    formData.append("inputs_local", file);
    request.send(formData);
  };

  local_yaml.addEventListener("change", event => {
    const files = event.target.files;
    uploadYaml(files[0]);
  });

  //function to send yaml url and extract the extra input parameters from response
  function sendYamlUrl() {
    const request = new XMLHttpRequest();
    const formData = new FormData();
    request.open("POST", "/extract_parameters", true);
    request.onreadystatechange = () => {
      if (request.readyState === 4 && request.status === 200) {
        var param = JSON.parse(request.responseText);
        const keys = Object.keys(param);
        while (container.hasChildNodes()) {
          container.removeChild(container.lastChild);
        }
        for (let i = 0; i < keys.length; i++) {
          const key = keys[i];
          console.log(key, param[key]);
          var input = document.createElement("input");
          var text_node = document.createTextNode(key + ": ");
          var line_break = document.createElement("br");

          input.type = param[key];
          input.name = key;
          container.appendChild(text_node);
          container.appendChild(input);
          container.appendChild(line_break);
        }
      }
      else if (request.readyState === 4) {
        while (container.hasChildNodes()) {
          container.removeChild(container.lastChild);
        }
      }

    };
    formData.append("inputs_url", url_yaml.value);
    request.send(formData);
  };

  url_yaml.addEventListener("change", event => {
    const files = event.target.files;
    sendYamlUrl();
  });

  //main function that sends the form (uses progress event to show a progress bar for uploading)
  function sendForm(e) {
    e.preventDefault();
    var xhr = new XMLHttpRequest();
    xhr.open("POST", "/launch");
    xhr.upload.addEventListener("progress", e => {
      console.log(e);
      const percent = e.lengthComputable ? (e.loaded / e.total) * 100 : 0;

      progressBarFill.style.width = percent.toFixed(2) + "%";
      progressBarText.textContent = percent.toFixed(2) + "%";
      if (percent == 100) {
        statusText.style.display = '';
      }
    });

    statusText.style.display = 'none';
    xhr.onreadystatechange = function () {
      if (xhr.readyState == XMLHttpRequest.DONE) {
        statusText.innerText = xhr.responseText;
        statusText.style.display = '';
        uploadText.style.display = 'none'
        progressBar.style.display = 'none'
        submitButton.style.display = '';
      }
    }

    data = new FormData(uploadForm);
    showProgressBar();
    xhr.send(data);
  }

  //helper function to hide/show elements of the page
  function showProgressBar() {
    if (uploadText.style.display == 'none') {
      uploadText.style.display = '';
    }
    if (progressBar.style.display == 'none') {
      progressBar.style.display = '';
    }
    submitButton.style.display = 'none';
  }

  //Jquery leftover. It makes inputs ascosciated with checked radio buttons required and
  // the opposite if not checked. It also clears values of inputs ascosciated with non checked radio buttons 
  var FormStuff = {
    init: function () {
      this.applyConditionalRequired();
      this.bindUIActions();
    },
    bindUIActions: function () {
      $("input[type='radio'], input[type='checkbox']").on("change", this.applyConditionalRequired);
    },
    applyConditionalRequired: function () {
      $(".require-if-active").each(function () {
        var el = $(this);
        if ($(el.data("require-pair")).is(":checked")) {
          el.prop("required", true);
        } else {
          el.val('');
          //el.change();
          el.prop("required", false);
        }
      });
    }
  };
  FormStuff.init();

  // Clears extra parameters when radio change for inputs yaml
  var rad = document.getElementsByName("workflow_yaml_input_method");
  for (var i = 0; i < rad.length; i++) {
    rad[i].addEventListener('change', function () {
      while (container.hasChildNodes()) {
        container.removeChild(container.lastChild);
      }
    });
  }

</script>
{% endblock %}